\input{../../include/schemes-two-stage}
\input{../../include/schemes}
\begin{document}
\begin{tikzpicture}[
    axis/.style = {draw = black, line width = \submatrixlinewidth},
    submatrix/.style = {draw = black, line width = \submatrixlinewidth},
    submatrixlabel/.style = {
      draw = black, fill = white, anchor = center, align = center,
      scale = \labelscale, inner sep = \labelinnersep,
      line width = \labellinewidth
    }
  ]
  % Top green and red lines.
  \draw[
    draw = green, line width = \sidelinewidth
  ] (-1.55 * \drawscale, 1.7 * \drawscale) node{}
  -- (0.45 * \drawscale, 1.7 * \drawscale);
  \draw[
    draw = red, line width = \sidelinewidth
  ] (0.55 * \drawscale, 1.7 * \drawscale) node{}
  -- (1.55 * \drawscale, 1.7 * \drawscale);
  % Left green and red lines.
  \draw[
    draw = green, line width = \sidelinewidth
  ] (-1.7 * \drawscale, 1.55 * \drawscale) node{}
  -- (-1.7 * \drawscale, -0.45 * \drawscale);
  \draw[
    draw = red, line width = \sidelinewidth
  ] (-1.7 * \drawscale, -0.55 * \drawscale) node{}
  -- (-1.7 * \drawscale, -1.55 * \drawscale);
  % Axis
  \draw[|-{latex[length=4mm]}, axis]
  (0.55 * \drawscale, 1.8 * \drawscale) node[
    anchor = south
  ] {\Large $1$}
  -- (0.965 * \drawscale, 1.8 * \drawscale) node[
    anchor = south
  ] {\Large $\mathbf{i}$}
  -- (1.55 * \drawscale, 1.8 * \drawscale) node[
    anchor = south
  ] {\Large $n_{BEM}/n_c$};
  % Sparse/dense matrix.
  \node[
    matrix, draw = black, line width = \matrixlinewidth,
    inner sep = \matrixinnersep
  ] (FB) at (0, 0) {
    \draw[
      submatrix, pattern = fillin, pattern color = green
    ] (0, 0) node[anchor = west]{}
    -- (2 * \drawscale, 0) node[anchor = north]{}
    -- (0, 2 * \drawscale) node[anchor = north west]{}
    -- cycle;
    \node[submatrixlabel] (Avv) at (1 * \drawscale, 1 * \drawscale) {
      $L_{vv}$ \\ [-2mm]
      {\tiny \textit{\textbf{creuse}}} \\ [-2mm]
      {\tiny \textit{avec remplissage}}
    }; &
    \draw[
      submatrix, pattern = dense, pattern color = orange
    ] (0.35 * \drawscale, 0) rectangle ++(0.15 * \drawscale, 2 * \drawscale);
    \node[submatrixlabel] (AsvT) at (0.425 * \drawscale, 1 * \drawscale) {
      $Y_i$ \\ [-2mm]
      {\tiny \textit{\textbf{dense}}}
    }; \\ [-3mm]
    \draw[
      submatrix, pattern = sparse,
    ] (0, 0) rectangle ++(2 * \drawscale, 1 * \drawscale);
    \node[submatrixlabel] (Asv) at (1 * \drawscale, 0.5 * \drawscale) {
      $A_{sv}$ \\ [-2mm]
      {\tiny \textit{\textbf{creuse}}}
    }; &
    \draw[submatrix]
       (0, 0) node[anchor = south west]{}
    -- (0, 1 * \drawscale) node[anchor = north west]{}
    -- (0.25 * \drawscale, 1 * \drawscale) node[anchor = north]{}
    -- (0.25 * \drawscale, 0.75 * \drawscale) node{}
    -- (0.5  * \drawscale, 0.75 * \drawscale) node{}
    -- (0.5  * \drawscale, 0.5  * \drawscale) node{}
    -- (0.75 * \drawscale, 0.5  * \drawscale) node{}
    -- (0.75 * \drawscale, 0.25 * \drawscale) node{}
    -- (1    * \drawscale, 0.25 * \drawscale) node[anchor = north east]{}
    -- (1    * \drawscale, 0    * \drawscale) node[anchor = south east]{}
    -- cycle;
    \draw[
      submatrix, pattern = dense, pattern color = red
    ] (0.35 * \drawscale, 0) rectangle
    ++(0.15  * \drawscale, 0.75 * \drawscale);
    \node[submatrixlabel] (S) at (0.5 * \drawscale, 0.5 * \drawscale) {
      $S_i$ \\ [-2mm]
      {\tiny \textit{\textbf{dense}}}
    }; \\
  };
  \draw[
    submatrix, pattern = dense, pattern color = black
  ] (2.35 * \drawscale, -1.55 * \drawscale) rectangle
  ++(0.15  * \drawscale,  1  * \drawscale);
  \node[submatrixlabel] (Z) at (2.4 * \drawscale, -1.05 * \drawscale) {
    $Z_i$ \\ [-2mm]
    {\tiny \textit{\textbf{dense}}}
  };
  \draw[-{Stealth[length=5mm]}, line width = \submatrixlinewidth] (Z) -- (S);
  \draw[-{Stealth[length=5mm]}, line width = \submatrixlinewidth] (AsvT) -- (Z);
\end{tikzpicture}
\end{document}
